%define ejudge_user ejudge
%define ejudge_group judges
%define ejudge_home /var/lib/ejudge
%define cgi_bin_dir /var/www/cgi-bin
%define httpd_htdocs_dir /var/www/html
%define ejudge_socket_dir /var/run/ejudge
%define lang_config_dir %_sysconfdir/ejudge/lang.d

Name: ejudge
Version: 2.3.12
Release: alt2

Summary: Ejudge is a programming contest managment system
Summary(ru_RU.UTF-8): Ejudge это система для проведения соревнований по программированию

License: GPL
Group: System/Servers
Url: http://www.ejudge.ru
Packager: Denis Kirienko <dk@altlinux.ru>

# SVN:  https://unicorn.cmc.msu.ru/svn/ejudge/trunk/ejudge/ 
Source0: %name-%version.tgz
Source1: %name.rc
Source2: ejudge-install.sh
Source3: ejudge-README-ALT.utf8
Source5: ejudge-cntsguide.pdf
Source6: ejudge-refmanual.pdf

BuildPreReq: flex, sed, iconv, mktemp, libexpat-devel, libreuse-devel >= 4.3.7, zlib-devel, libncursesw-devel, libMySQL-devel

Requires: sharutils, webserver, libreuse >= 4.3.7, e2fsprogs, iconv, a2ps, gawk

%description
Ejudge is a programming contest managment system.

%description -l ru_RU.UTF-8
Ejudge - это система для организации соревнований по программированию.
Она позволяет участникам соревнований сдавать решения предлагаемых
задач, которые проверяются на заранее подготовленных тестах.
Также ejudge позволяет проводить тестирования на различных видах
задач: с выбором ответа, с кратким или развернутым ответом.

%prep
%setup -q -n ejudge
cp %SOURCE2 %SOURCE3 %SOURCE5 %SOURCE6 .

sed -i -e "s/@EJUDGE_VERSION@/%version/" ejudge-README-ALT.utf8

SUBST=`echo %cgi_bin_dir | sed "s/\\//\\\\\\\\\//g"`
sed -i -e "s/@CGI_BIN_DIR@/$SUBST/" ejudge-README-ALT.utf8
sed -i -e "s/\\/var\\/www\\/cgi-bin/$SUBST/g" ejudge-install.sh

SUBST=`echo %httpd_htdocs_dir | sed "s/\\//\\\\\\\\\//g"`
sed -i -e "s/@HTTPD_HTDOCS_DIR@/$SUBST/" ejudge-README-ALT.utf8
sed -i -e "s/\\/var\\/www\\/html/$SUBST/g" ejudge-install.sh

%build

# Converting documentation from KOI-8 to UTF-8
for f in  *.RUS
do
	TMPFILE=`mktemp`
	iconv -f KOI-8 -t UTF-8 -c $f -o $TMPFILE || /bin/true
	cat $TMPFILE > $f
	rm $TMPFILE
done

%configure                                                                \
--enable-charset=utf-8                                                    \
--enable-socket-path=%ejudge_socket_dir/userlist-socket                   \
--enable-super-serve-socket=%ejudge_socket_dir/super-serve-socket         \
--enable-new-server-socket=%ejudge_socket_dir/new-server-socket           \
--enable-contests-home-dir=%ejudge_home                                   \
--libexec=%_libexecdir                                                    \
--enable-cgi-bin-dir=%_libexecdir/%name/cgi-bin                           \
--enable-conf-dir=%ejudge_home/data                                       \
--enable-cgi-conf-dir=../cgi-data                                         \
--enable-hidden-server-bins                                               \
--with-reuse=%_prefix                                                     \
--with-httpd-cgi-bin-dir=%cgi_bin_dir                                     \
--with-httpd-htdocs-dir=%httpd_htdocs_dir                                 \
--enable-ajax                                                             \
--enable-lang-config-dir=%lang_config_dir

%make_build RELEASE=1

%install
%make_install DESTDIR=%buildroot install
install -p -m755 -D %SOURCE1 %buildroot%_initdir/%name
install -d %buildroot%ejudge_home
install -d %buildroot%ejudge_socket_dir
install -d %buildroot%lang_config_dir

%pre
%_sbindir/groupadd -r -f %ejudge_group 2>/dev/null || :
%_sbindir/useradd -g %ejudge_group -c 'Ejudge server' -d %ejudge_home -r %ejudge_user 2>/dev/null || :

%post
%post_service ejudge

%preun
%preun_service ejudge

%files
%_sysconfdir/ejudge
%attr(2775,%ejudge_user,%ejudge_group) %dir %ejudge_home
%attr(0775,%ejudge_user,%ejudge_group) %dir %ejudge_socket_dir
%_initdir/%name
%_bindir/*
%_includedir/*
%_libdir/libchecker*
%_libexecdir/%name
%_datadir/%name
# FIXME: разобраться с корректной локализацией
%_datadir/locale/*/LC_MESSAGES/*
%doc AUTHORS ChangeLog FAQ.RUS INSTALL INSTALL.RUS NEWS NEWS.RUS OLDNEWS TODO UPGRADE UPGRADE.RUS ejudge-install.sh ejudge-README-ALT.utf8 ejudge-*.pdf

%changelog
* Mon Dec 08 2008 Denis Kirienko <dk@altlinux.ru> 2.3.12-alt2
- SVN snapshot 5405 

* Sun Nov 30 2008 Denis Kirienko <dk@altlinux.ru> 2.3.12-alt1
- Version 2.3.12+ (SVN 5366)
- Updated README

* Sun Oct 12 2008 Denis Kirienko <dk@altlinux.ru> 2.3.11-alt1
- Version 2.3.11 (svn 5201)
- Enabled MySQL support

* Thu Sep 11 2008 Denis Kirienko <dk@altlinux.ru> 2.3.9-alt5
- SVN snapshot 5048

* Sun Aug 24 2008 Denis Kirienko <dk@altlinux.ru> 2.3.9-alt4
- Fixed bug with wrong shell for user ejudge
- Fixed bug with JAVA_HOME variable
- Updated README-ALT

* Fri Aug 15 2008 Denis Kirienko <dk@altlinux.ru> 2.3.9-alt3
- SVN snapshot 4999
- Rebuild with libreuse-4.3.6-alt2

* Fri Aug 15 2008 Denis Kirienko <dk@altlinux.ru> 2.3.9-alt2
- Update for version 2.3.9 (svn 4998) - important bugfix 

* Sat Aug 09 2008 Denis Kirienko <dk@altlinux.ru> 2.3.9-alt1
- Version 2.3.9 (svn 4993)

* Thu Jul 7 2008 Denis Kirienko <dk@altlinux.ru> 2.3.8-alt1
- Version 2.3.8 (svn 4990)
- New programming languages configuration scheme
- Updated README-ALT

* Sun Mar 16 2008 Denis Kirienko <dk@altlinux.ru> 2.3.7-alt1
- Version 2.3.7 (svn 4802)
- Added dependencies to e2fsprogs and iconv (required by ejudge-install.sh)
- Language config files are marked as config(noreplace)

* Tue Feb 26 2008 Denis Kirienko <dk@altlinux.ru> 2.3.6-alt1.svn4705
- Version 2.3.6 

* Fri Jan 11 2008 Denis Kirienko <dk@altlinux.ru> 2.3.5-alt0.svn4652
- Version 2.3.5 

* Sun Dec 23 2007 Denis Kirienko <dk@altlinux.ru> 2.3.3-alt0.svn4638
- New svn snapshot
- Fixed ejudge-install.sh script
- Fixed java support
- Updated README-ALT
- Added PDF documentation

* Sat Sep 15 2007 Denis Kirienko <dk@altlinux.ru> 2.3.3-alt0.svn4327
- New svn snapshot
- Fixed configure bug (ejudge refused to start at i586)

* Sun Aug 26 2007 Denis Kirienko <dk@altlinux.ru> 2.3.3-alt0.svn4320
- Version 2.3.3 
- rebuilded with new configure option: --enable-hidden-server-bins 

* Thu Aug 16 2007 Denis Kirienko <dk@altlinux.ru> 2.3.2-alt0.svn4307
- New svn snapshot 
- updated README-ALT

* Wed Aug 08 2007 Denis Kirienko <dk@altlinux.ru> 2.3.2-alt0.svn4303
- New svn snapshot 

* Sun Aug 05 2007 Denis Kirienko <dk@altlinux.ru> 2.3.2-alt0.svn4282
- New svn snapshot
- Rebuild with new reuse library
- Fixed support for g++, javac, fpc compilers
- Updated alt-locale patch

* Fri Aug 03 2007 Denis Kirienko <dk@altlinux.ru> 2.3.2-alt0.svn4255
- New svn snapshot 

* Sun Apr 15 2007 Denis Kirienko <dk@altlinux.ru> 2.3.2-alt0.svn4105
- New svn snapshot 

* Mon Apr 09 2007 Denis Kirienko <dk@altlinux.ru> 2.3.2-alt0.svn4088
- New svn snapshot 
- alt-locale patch
- updated README-ALT
- updated ejudge-install.sh

* Sun Apr 08 2007 Denis Kirienko <dk@altlinux.ru> 2.3.2-alt0.svn4084
- Initital build for ALT Linux
